> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ilyama.golain.io/llms.txt
> Use this file to discover all available pages before exploring further.

# PUT /projects/{project_id}/environments/{env_id}/variables



## OpenAPI

````yaml /api-reference/ilyama.v1.json put /projects/{project_id}/environments/{env_id}/variables
openapi: 3.1.0
info:
  description: >
    Generation-ready starter contract for ilyama's HTTP API.

    This is intentionally scoped to stable routes already mounted in
    services/apis

    so frontend clients can begin integrating against the rewrite immediately.
  title: ilyama Core API
  version: 0.1.0
servers:
  - url: /core/api/v1
security:
  - bearerAuth: []
tags:
  - name: Certificates (HTTP)
  - name: Device JITR
  - name: Device RPC
  - name: Devices
  - name: Edge replication
  - name: Fleets
  - name: Integrations
  - name: MDM
  - name: Notification Event Registry
  - name: Notifications
  - name: OTA
  - name: Observability & data
  - name: Organizations
  - name: Project settings
  - name: Projects
  - name: Projects — Email Templates
  - name: Projects — Notification Subscriptions
  - name: Projects — Status
  - name: System
  - name: Tickets & workflows
  - name: Webhooks
paths:
  /projects/{project_id}/environments/{env_id}/variables:
    put:
      tags:
        - Project settings
      summary: PUT /projects/{project_id}/environments/{env_id}/variables
      operationId: putProjectsProjectIdEnvironmentsEnvIdVariables
      parameters:
        - in: path
          name: project_id
          required: true
          schema:
            type: string
        - in: path
          name: env_id
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              additionalProperties: true
              type: object
          multipart/form-data:
            schema:
              additionalProperties: true
              type: object
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                additionalProperties: true
                type: object
          description: Successful response
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
          description: Bad request
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
          description: Unauthorized
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
          description: Forbidden
      security:
        - bearerAuth: []
          orgIdHeader: []
components:
  schemas:
    ErrorEnvelope:
      properties:
        detail:
          type: string
        message:
          oneOf:
            - type: string
            - type: object
        ok:
          enum:
            - 0
          type: integer
      required:
        - ok
        - message
        - detail
      type: object
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      scheme: bearer
      type: http
    orgIdHeader:
      in: header
      name: ORG-ID
      type: apiKey

````